﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Public FindFilesList As List
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	FindFilesList.Initialize
End Sub

Public Sub selectFolder(Form1 As Form) As String              
  Dim dc As DirectoryChooser
  dc.Initialize
  dc.InitialDirectory = File.DirTemp
  dc.Title = "Select a Folder"
  Dim folder As String
  dc.Show(Form1)
  Return folder 
End Sub

' Find files in a folder resursive
' Parameter Path to find files from
' Returns List of files in a global var FindFileList As List (must initialized)
' Example usage:
'  Dim dir As String = File.DirApp
'  FFileList.Clear
'  FindFiles(dir)
'  listviewFiles.Items.AddAll(FFileList)
Sub findFiles(Path As String, sep As String)
  Dim FileList, FolderList As List
  Dim FileFound As String
  FileList.Initialize
  FolderList.Initialize
  If Path = "" Then Path = File.DirApp
	'Path = Path.Replace("\", "/")
  If File.IsDirectory(Path,"") Then
    Try
      FileList = File.ListFiles(Path)
      If FileList.IsInitialized Then
        If FileList.Size > 0 Then
          FileFound = Path
          FindFilesList.Add(FileFound)
          For i = 0 To FileList.Size - 1
            FileFound = FileList.Get(i)
            If File.IsDirectory(Path & sep & FileFound,"") Then
              FolderList.Add(Path & sep & FileFound)
            Else
              FindFilesList.Add(Path & sep & FileFound)
            End If
          Next
        End If
      End If
    Catch
      Log(LastException & " " & Path & " " & FileList.Size & " (File)")
    End Try
    'Recursive search for files
    Try
      If FolderList.IsInitialized Then
        If FolderList.Size > 0 Then
          For i = 0 To FolderList.Size - 1
            FileFound = FolderList.Get(i)
            findFiles(FileFound, sep)
          Next
        End If
      End If
    Catch
      Log(LastException & " " & FolderList.Size & " " & FileFound & " (Folder)")
    End Try
  End If
End Sub

' Returns the filename from a fullpath
Sub getFileName(path As String) As String
  ' Define the JavaObject
  Dim fileO As JavaObject
  ' Get the fileio class
  fileO.InitializeNewInstance("java.io.File", Array As Object(path))
  ' Getthe filename
  Return fileO.RunMethod("getName", Null)
End Sub

' Returns the filepath from a fullpath
Sub getFilePath(path As String) As String
  ' Define the JavaObject
  Dim fileO As JavaObject
  ' Get the fileio class
  fileO.InitializeNewInstance("java.io.File", Array As Object(path))
  ' Getthe filename and path
  Dim n As String = fileO.RunMethod("getName", Null)
  Dim p As String = fileO.RunMethod("getPath", Null)
  p = p.Replace(n, "")
  Return p
End Sub
